/*
 * generated by Xtext
 */
package hu.bme.mit.inf.socialnetwork.language.scoping

import com.google.inject.Inject
import hu.bme.mit.inf.socialnetwork.language.services.SocialNetworkLanguageGrammarAccess
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter
import org.eclipse.xtext.formatting.impl.FormattingConfig

/**
 * This class contains custom scoping description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation.html#scoping
 * on how and when to use it 
 *
 */
class SocialNetworkLanguageFormatter extends AbstractDeclarativeFormatter {

	@Inject extension SocialNetworkLanguageGrammarAccess
	
	override protected void configureFormatting(FormattingConfig c) {
		c.setLinewrap(0, 1, 2).before(getSL_COMMENTRule)
		c.setLinewrap(0, 1, 2).before(getML_COMMENTRule)
		c.setLinewrap(0, 1, 1).after(getML_COMMENTRule)

		val sna = getSocialNetworkAccess
		c.setLinewrap(1, 1, 1).after(sna.leftCurlyBracketKeyword_3)
		c.setLinewrap(1, 1, 1).before(sna.rightCurlyBracketKeyword_5)
		c.setLinewrap(1, 1, 1).after(sna.entitiesAssignment_4)
		c.setIndentationIncrement.after(sna.leftCurlyBracketKeyword_3)
		c.setIndentationDecrement.before(sna.rightCurlyBracketKeyword_5)
		
		val ca = getCommunityAccess
		c.setLinewrap(1, 1, 1).after(ca.leftCurlyBracketKeyword_2_0)
		c.setLinewrap(1, 1, 1).before(ca.rightCurlyBracketKeyword_2_2)
		c.setIndentationIncrement.after(ca.leftCurlyBracketKeyword_2_0)
		c.setIndentationDecrement.before(ca.rightCurlyBracketKeyword_2_2)
		
		val pa = getPersonAccess
		c.setLinewrap(1, 1, 1).after(pa.leftCurlyBracketKeyword_2)
		c.setLinewrap(1, 1, 1).after(pa.leftCurlyBracketKeyword_4)
		c.setLinewrap(1, 2, 2).before(pa.rightCurlyBracketKeyword_6)
		c.setLinewrap(1, 1, 1).before(pa.rightCurlyBracketKeyword_8)
		
		// c.setNoSpace.before(pa.commaKeyword_5_1_0)
		// c.setLinewrap(1, 1, 1).after(pa.commaKeyword_5_1_0)		
		
		c.setIndentationIncrement.after(pa.leftCurlyBracketKeyword_2)
		c.setIndentationIncrement.after(pa.leftCurlyBracketKeyword_4)
		c.setIndentationDecrement.before(pa.rightCurlyBracketKeyword_6)
		c.setIndentationDecrement.before(pa.rightCurlyBracketKeyword_8)	
		
		val aa = acquaintaceAccess
		c.setLinewrap(1,1,1).before(aa.typeAssignment_0)
	}
}
